//-------------
//  tsr.cpp
//  (c) Victor A.Voilevitch, 1994-1996.
//-------------

#include "tsr.h"
#include "tsr_prep.h"

#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <time.h>


//---------------------------------------
//--#######--#######--#######------------
//-----#-----#--------#-----#------------
//-----#-----#######--#######------------
//-----#-----------#--#--#---------------
//-----#-----#######--#---##-------------
//---------------------------------------

/*
 class TSR
 */

//-----------------------------------------------------
TSR::TSR( char * _name,
          FUNCTION function,
          FUNCTION unload_function,
          char p_ID,
          int hot_key,
          int hot_shift,
          unsigned long delta_time,
          char make_28,
          char make_13
        ) :
   name(_name),
   size(_SS+(_SP+15)/16-_psp+(_stklen+15)/16 )  // !!!!!!!!!!!!!!!!!
{ _AH=0x34;
  geninterrupt (0x21);
  inside_DOS=(char far*) MK_FP(_ES,_BX);
  TSR_DTA = getdta();
  FLAG_HOT_KEY_SCAN   = hot_key;
  FLAG_HOT_KEY_SHIFT  = hot_shift;
  DELTA_TIME          = delta_time;
  WORK_FUNCTION       = function;
  USER_UNLOAD_FUNCTION= unload_function;
  FLAG_REPLACE_28     = make_28!=0;
  FLAG_REPLACE_13     = make_13!=0;
  PROGRAM_ID          = p_ID;
}
//-----------------------------------------------------
COMMAND_LINE TSR::is_cmdl(int argc, char *argv[])
{ if(argc>1)
  { if( !strcmp(argv[1],"/?") ||
        !strcmp(argv[1],"/h") ||
        !strcmp(argv[1],"/H")
      ) return CL_HELP;
    if( !strcmp(argv[1],"/L") ||
        !strcmp(argv[1],"/l")
      ) return CL_UNLOAD;
    if( !strcmp(argv[1],"/S") ||
        !strcmp(argv[1],"/s")
      ) return CL_SLEEP;
    if( !strcmp(argv[1],"/A") ||
        !strcmp(argv[1],"/a")
      ) return CL_AWAKE;
    if( !strcmp(argv[1],"/Z") ||
        !strcmp(argv[1],"/z")
      ) return CL_KEEP;
    return CL_BADKEY;
  }
  return CL_KEEP;
}

//-----------------------------------------------------
int TSR::load(void)
{ puts("㧪...");
  if(FLAG_HOT_KEY_SCAN)
  { old_09 = getvect(0x09);
    setvect(0x09,new_09);
  }
  old_1C = getvect(0x1C);
  setvect(0x1C,new_1C);
  if(FLAG_REPLACE_28)
  { old_28 = getvect(0x28);
    setvect(0x28,new_28);
  }
  if(FLAG_REPLACE_13)
  { old_13 = getvect(0x13);
    setvect(0x13,((void interrupt (*)(__ARGS))(new_13)));
  }
  old_2F = getvect(0x2F);
  _fmemcpy ( ((char far *)(NEW_2F))+OFFSET_28, &old_2F, 4 );
  unsigned seg =  FP_SEG(&FLAG_TO_UNLOAD);
  unsigned off =  FP_OFF(&FLAG_TO_UNLOAD);
  _fmemcpy ( ((char far *)(NEW_2F))+OFFSET_DS, &seg,    2 );
  _fmemcpy ( ((char far *)(NEW_2F))+OFFSET_FL, &off,    2 );
  seg =  FP_SEG(&FLAG_UNLOADING);
  off =  FP_OFF(&FLAG_UNLOADING);
  _fmemcpy ( ((char far *)(NEW_2F))+OFFSET_DS_SL, &seg,    2 );
  _fmemcpy ( ((char far *)(NEW_2F))+OFFSET_FL_SL, &off,    2 );
  _fmemcpy ( ((char far *)(NEW_2F))+OFFSET_DS_AW, &seg,    2 );
  _fmemcpy ( ((char far *)(NEW_2F))+OFFSET_FL_AW, &off,    2 );
  setvect( 0x2F, ((void interrupt (*)(__ARGS))(NEW_2F)) );
  return Ok;
}

//-----------------------------------------------------
int TSR::unload(void)
{ puts("㧪...");
  REGS r;
  r.h.ah = PROGRAM_ID;
  r.h.al = 1;
  int86(0x2f,&r,&r);
  long start = clock();
  long stop;
  do stop = clock();
  while( ( stop - start ) < WAIT_UNLOAD );
  return already_loaded()==No;
}

//-----------------------------------------------------
int TSR::leave(void)
{ puts("㦠...");
  if(!unload())
  { puts(name);
    puts("\a\a: 㧪 ");
  }
  else puts("㧪 祭.");
  return Ok;
}

//-----------------------------------------------------
void TSR::keep(void)
{ puts("㦠...");
  if(!load())
  { puts(name);
    puts("\a\a: 㧪 ");
  }
  else puts("㧪 祭.");
  ::keep(0,size);
  puts("\a\a: 訡 㧪!");
}

//-----------------------------------------------------
void TSR::sleep(void)
{ puts("⨢...");
  REGS r;
  r.h.ah = PROGRAM_ID;
  r.h.al = 2;
  int86(0x2f,&r,&r);
}


//-----------------------------------------------------
void TSR::awake(void)
{ puts("A⨢...");
  REGS r;
  r.h.ah = PROGRAM_ID;
  r.h.al = 3;
  int86(0x2f,&r,&r);
}

//-----------------------------------------------------
int TSR::already_loaded(void)
{ REGS r;
  r.h.ah = PROGRAM_ID;
  r.h.al = 0;
  int86(0x2f,&r,&r);
  return r.h.al==0xff;
}

