//-------------
//  tsr.h
//  (c) Victor A.Voilevitch, 1994-1996.
//-------------

#ifndef Ok
#define Ok 1
#define Yes 1
#define No 0
#endif

#ifndef __TSR_CLASS__
#define __TSR_CLASS__

#include <stdio.h>
#include <string.h>
#include <dos.h>

#include "tsr_prep.h"

//---------------------------------------
enum COMMAND_LINE
{ CL_HELP,
  CL_UNLOAD,
  CL_SLEEP,
  CL_AWAKE,
  CL_BADKEY,
  CL_KEEP
};

//---------------------------------------
class TSR
{
  private:
    //-----------------------------------------------------
    char * name;
    //-----------------------------------------------------
  protected:
    //-----------------------------------------------------
    unsigned size;
    int load(void);
    int unload(void);
    //-----------------------------------------------------
  public:
    //-----------------------------------------------------
    TSR( char * _name,
         FUNCTION function,
         FUNCTION unload_function,
         char p_ID                = 0xFA,
         int  hot_key             = 0,
         int  hot_shift           = CTRL,
         unsigned long delta_time = 0,
         char make_28             = No,
         char make_13             = No
       );
    COMMAND_LINE is_cmdl(int argc, char *argv[]);
    int already_loaded(void);
    int leave(void);
    void keep(void);
    void sleep(void);
    void awake(void);
    char *   is_name(void) const { return name;    }
    unsigned is_size(void) const { return size;    }
    //-----------------------------------------------------
};

#endif

