//-------------
// tsrmaker.cpp
//-------------

#include "tsr_prep.h"
#include "tsr.h"

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <bios.h>
#include <time.h>
#include <process.h>
#include <stdlib.h>
#include <alloc.h>

TSR_PREPARE()

const LEFT     = 33;
const RIGHT    = 58;
const TOP      = 10;
const BOTTOM   = 19;
const COLOR    = 31;
int x__;
int y__;


int beep(void)
{ static char buffer[2*(RIGHT-LEFT+1)*(BOTTOM-TOP+1)];
  x__ = wherex();
  y__ = wherey();
  gettext(LEFT, TOP, RIGHT, BOTTOM, buffer);
  textattr(COLOR);
  for(int col = LEFT; col<=RIGHT;col++)
     for(int row = TOP; row<=BOTTOM;row++)
     { gotoxy(col,row);
       cputs("");
     }
  for(int i = 0; ! bioskey(1) && i < 10 ; i++)
  { sound(1000*(1+i%2));
    delay(100);
    nosound();
  }
  if(FLAG_TIMER_DONE)
  { gotoxy(LEFT,TOP);
    cputs("Timer");
  }
  if(FLAG_KEY_PRESSED)
  { gotoxy(LEFT+10,TOP);
    cputs("Keyboard");
  }
  gotoxy(LEFT+3,TOP+1);
  cputs("Hello !!!");
  gotoxy(LEFT+2,TOP+3);
  cputs("1. Continue");
  gotoxy(LEFT+2,TOP+4);
  cputs("2. Break");
  gotoxy(LEFT+2,TOP+5);
  cputs("3. Sleep");
  gotoxy(LEFT+2,TOP+6);
  cputs("4. Try to load SYSINFO");
  int bye = No;
  static char mem_released;
  mem_released = No;
  do switch(char(bioskey(0)))
  { case '1' : bye = Yes;
               break;
    case '3' : FLAG_UNLOADING = Yes;
               bye = Yes;
               break;
    case '2' : FLAG_TO_UNLOAD = Yes;
               bye = Yes;
               break;
    case '4' : if(!mem_released)
               { mem_released = Yes;
                 /*
                 REGS r;
                 SREGS sr;
                 segread(&sr);
                 r.h.ah = 0x4a;
                 sr.es = old_PSP;
                 r.x.bx = 200000L / 16;
                 int86x(0x21,&r,&r,&sr);
                 if(r.x.cflag)
                 { gotoxy(LEFT+2,TOP+7);
                   cputs(sys_errlist[errno]);
                 }
                 */
               }
               if(system("sysinfo"))
               { gotoxy(LEFT+2,TOP+8);
                 cputs(sys_errlist[errno]);
               }
               break;
    default  : sound(100);
               delay(100);
               nosound();
  } while(!bye);
  puttext(LEFT, TOP, RIGHT, BOTTOM, buffer);
  gotoxy(x__,y__);
  return Yes;
}

TSR tsr( "BEEP",           //    
         beep,             //    ࠡ 㭪
         NULL,             //    ⠭⭠ 㭪 㧪
         0xFA,             //    ID ணࠬ ( 0xF0 ... 0xFF )
         0x1F,             //    'S' \   
         CTRL,             //        /
         60*CLK_TCK,       //    ਮ ⮬᪮ ࠡ뢠
         Yes,              //    ᪮  INT 28 (᫨    .)
         Yes               //        ᪮
       );

int main ( int argc, char * argv[] )
{ puts("---        TSR installator         ---");
  switch(tsr.is_cmdl(argc,argv))
  { case CL_BADKEY  : puts(tsr.is_name());
                      puts(": bad key");
    case CL_HELP    : puts(tsr.is_name());
                      puts("\t/L - unload\n"
                           "\t/S - sleep\n"
                           "\t/H - help"
                          );
                      return 0;
    case CL_UNLOAD  : if(!tsr.already_loaded())
                      { puts(tsr.is_name());
                        puts(": not in memory");
                        return 0;
                      }
                      else return tsr.leave();
    case CL_SLEEP   : if(!tsr.already_loaded())
                      { puts(tsr.is_name());
                        puts(": not in memory");
                        return 0;
                      }
                      else
                      { tsr.sleep();
                        return 0;
                      }
    case CL_AWAKE   : if(!tsr.already_loaded())
                      { puts(tsr.is_name());
                        puts(": not in memory");
                        return 0;
                      }
                      else
                      { tsr.awake();
                        return 0;
                      }
    case CL_KEEP    : if(tsr.already_loaded())
                      { puts(tsr.is_name());
                        puts(": already loaded");
                        return 0;
                      }
                      else tsr.keep();
    default         : puts(tsr.is_name());
                      puts(": unknown error");
                      return 1;
  }
}
