//-------------
//  tsr_prep.cpp
//  (c) Victor A.Voilevitch, 1994-1996.
//-------------

#include "tsr_prep.h"

#include <dos.h>
#include <bios.h>
#include <io.h>


//---------------------------------------------------
// ID ணࠬ ( INT 2F)
//---------------------------------------------------
char PROGRAM_ID = 0xFA;



//---------------------------------------------------
// ࠡ 㭪 ணࠬ
//---------------------------------------------------
FUNCTION WORK_FUNCTION = No;
void FULL_WORK_FUNCTION(void)
{       FLAG_WORKING = Yes;
        old_ss=_SS;
        old_sp=_SP;
        disable();
        _SS=TSR_ss;
        _SP=TSR_sp;
        enable();
        _AH=0x62;
        geninterrupt(0x21);
        old_PSP=_BX;
        _AH=0x50;
        _BX=_psp;
        geninterrupt(0x21);
        old_DTA = getdta();
        setdta(TSR_DTA);
        old_24 = getvect(0x24);
        setvect(0x24,((void interrupt (*)(__ARGS))(new_24)));
        old_23 = getvect(0x23);
        setvect(0x23,((void interrupt (*)(__ARGS))(new_23)));
        if( FLAG_START     &&
            WORK_FUNCTION  &&
            ! FLAG_UNLOADING
          ) if(WORK_FUNCTION())
            { FLAG_START = No;
              FLAG_TIMER_DONE = No;
              FLAG_KEY_PRESSED = No;
            }
        if( FLAG_TO_UNLOAD &&
            ! FLAG_UNLOADING
          ) UNLOAD_FUNCTION();
        setvect(0x23,old_23);
        setvect(0x24,old_24);
        setdta(old_DTA);
        _AH=0x50;
        _BX=old_PSP;
        geninterrupt(0x21);
        disable();
        _SS=old_ss;
        _SP=old_sp;
        enable();
        FLAG_WORKING = No;
}

//---------------------------------------------------
// 㭪  㧪 ணࠬ
//---------------------------------------------------
FUNCTION USER_UNLOAD_FUNCTION = No;
void UNLOAD_FUNCTION(void)
{ FLAG_UNLOADING = Yes;
  if(USER_UNLOAD_FUNCTION) USER_UNLOAD_FUNCTION();
  if( getvect(0x1C) == new_1C
      &&
      ( ! FLAG_HOT_KEY_SCAN
        ||
        getvect(0x09) == new_09
      )
      &&
      ( ! FLAG_REPLACE_28
        ||
        getvect(0x28) == new_28
      )
      &&
      ( ! FLAG_REPLACE_13
        ||
        getvect(0x13) == ((void interrupt (*)(__ARGS))(new_13))
      )
      &&
      getvect(0x2F) == ((void interrupt (*)(__ARGS))(NEW_2F))
    )
  { if( FLAG_HOT_KEY_SCAN && old_09 )  setvect(0x09,old_09);
    if(                      old_1C )  setvect(0x1C,old_1C);
    if( FLAG_REPLACE_28   && old_28 )  setvect(0x28,old_28);
    if( FLAG_REPLACE_13   && old_13 )  setvect(0x13,old_13);
    if(                      old_2F )  setvect(0x2F,old_2F);
    unsigned env_seg = *(unsigned far *)MK_FP(_psp,0x2c);
    freemem( _psp    );
    freemem( env_seg );
    for(int handle=0; handle<5; ++handle ) close(handle);
    FLAG_TO_UNLOAD = No;   //  \ ⮨  ?
    FLAG_UNLOADING = No;   //  /
  }
}


//---------------------------------------------------
// ⥪ ࠡ稪 뢠,
// 祭 SS,SP  ࠡ ࠡ稪
//---------------------------------------------------
unsigned char far        TSR_stack   [STACK_LEN];
unsigned TSR_ss = FP_SEG(TSR_stack);
unsigned TSR_sp = FP_OFF(TSR_stack) + STACK_LEN;

//---------------------------------------------------
// SS  SP 䮭 ணࠬ  室  ࠡ稪
// PID 䮭 ணࠬ
//---------------------------------------------------
unsigned old_ss, old_sp;
unsigned old_PSP;

//---------------------------------------------------
// DTA ࠡ祩  䮭 ணࠬ
//---------------------------------------------------
char far * old_DTA;
char far * TSR_DTA;


//---------------------------------------------------
//  䫠 ॥ࠡ쭮 MS DOS
//---------------------------------------------------
char far * inside_DOS;

//---------------------------------------------------
//  䫠
//---------------------------------------------------
char FLAG_TIMER_DONE     = No;;
char FLAG_KEY_PRESSED    = No;;
//------------------------
char FLAG_WORKING        = No;
char FLAG_UNLOADING      = No;
//------------------------
char FLAG_START          = No;
int  FLAG_TO_UNLOAD      = No;
//------------------------
char FLAG_INSIDE_09      = No;
int  FLAG_HOT_KEY_SCAN   = 0;
int  FLAG_HOT_KEY_SHIFT  = 0;
//------------------------
char FLAG_INSIDE_1C      = No;
unsigned long DELTA_TIME = 0LU;
//------------------------
char FLAG_REPLACE_28     = No;
char FLAG_INSIDE_28      = No;
//------------------------
char FLAG_REPLACE_13     = No;
char FLAG_INSIDE_13      = No;


//---------------------------------------------------
//  ࠡ稪 뢠
//---------------------------------------------------
void interrupt ( *old_09)(__ARGS) = No;
void interrupt    new_09 (__ARGS)
{ old_09();
  disable();
  if( ! FLAG_UNLOADING )
  { if( ! FLAG_INSIDE_09 )
    { FLAG_INSIDE_09 = Yes;
      if( (bioskey(2) & FLAG_HOT_KEY_SHIFT) == FLAG_HOT_KEY_SHIFT )
      { if( inportb(0x60) == FLAG_HOT_KEY_SCAN )
        { bioskey(0);
          FLAG_START = Yes;
          FLAG_KEY_PRESSED = Yes;
        }
      }
      FLAG_INSIDE_09 = No;
    }
  }
  enable();
}

//---------------------------------------------------
void interrupt (*old_1C)(__ARGS);
static unsigned long current_time = 0LU;
void interrupt   new_1C (__ARGS)
{ old_1C();
  disable();
  if( ! FLAG_UNLOADING )
  { if( ! FLAG_INSIDE_1C )
    { FLAG_INSIDE_1C = Yes;
      if( DELTA_TIME )
      { if( ++current_time >= DELTA_TIME )
        { current_time = 0LU;
          FLAG_START = Yes;
          FLAG_TIMER_DONE = Yes;
        }
      }
      if( ( FLAG_START      ||
            FLAG_TO_UNLOAD
          )                 &&
          ! (*inside_DOS)   &&
          ! FLAG_WORKING    &&
          ! FLAG_INSIDE_13
        )
      { outportb(0x20,0x20);
        FULL_WORK_FUNCTION();
      }
      FLAG_INSIDE_1C = No;
    }
  }
  enable();
}

//---------------------------------------------------
void interrupt (*old_28)(__ARGS) = No;
void interrupt new_28 (__ARGS)
{ if( ! FLAG_INSIDE_28 )
  { FLAG_INSIDE_28 = Yes;
    old_28();
    if( ! FLAG_UNLOADING )
    { if( ( FLAG_START     ||
            FLAG_TO_UNLOAD
          )                &&
          ! FLAG_WORKING   &&
          ! FLAG_INSIDE_13
        ) FULL_WORK_FUNCTION();
    }
    FLAG_INSIDE_28 = No;
  }
}

//---------------------------------------------------
void interrupt (*old_13)(__ARGS) = No;
#pragma argsused
void interrupt new_13 (__FULL_ARGS)
{ FLAG_INSIDE_13 = Yes;
  old_13();
  disable();
  out_ax=_AX;
  asm    pushf
  asm    pop out_flags;
  FLAG_INSIDE_13 = No;
}

//---------------------------------------------------
void interrupt (*old_2F)(__ARGS) = No;

//---------------------------------------------------
void interrupt (*old_24)(__ARGS) = No;
#pragma argsused
void interrupt new_24 (__FULL_ARGS)
{ out_ax = 3;   // Fail
}

//---------------------------------------------------
void interrupt (*old_23)(__ARGS) = No;
#pragma argsused
void interrupt new_23 (__FULL_ARGS)
{               // Ignore
}
